<?php

namespace App\Repository;

use App\Entity\Group;
use App\Entity\Provider;
use App\Entity\Sector;
use Doctrine\ORM\EntityRepository;

/**
 * GroupRepository.
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class GroupRepository extends EntityRepository
{
    /*
    public function getNotImportedGroups($rootGroup)
    {
        $em = $this->getEntityManager();
        $query = $em->getRepository('App\Entity\GroupComposition')
            ->createQueryBuilder('c')
            ->select('c.subGroup')
            ->where('c.rootGroup = :root_group AND c.imported = false')
            ->setParameter('root_group', $rootGroup)
            ->getQuery();
        $groups = $query->getResult();
        $groupsList = array();
        foreach ($groups as $groupComposition) {
            $groupsList[] = LdapTool::ldapEscape($groupComposition['subGroup']);
        }

        return $groupsList;
    }

    public function removeAllImported($rootGroup)
    {
        $em = $this->getEntityManager();
        $query = $em->getRepository('App\Entity\GroupComposition')
            ->createQueryBuilder('c')
            ->delete()
            ->where('c.rootGroup = :root_group AND c.imported = true')
            ->setParameter('root_group', $rootGroup)
            ->getQuery();
        $result = $query->getResult();

        return $result;
    }

    public function getAllSubGroup($name)
    {
        $em = $this->getEntityManager();
        $query = $em->getRepository('App\Entity\GroupComposition')
            ->createQueryBuilder('c')
            ->select('c.subGroup')
            ->where('c.rootGroup = :name ')
            ->setParameter('name', $name)
            ->distinct('c.subGroup')
            ->getQuery();
        $groupsList = array();
        $results = $query->getResult();
        foreach ($results as $result) {
            $groupsList[] = $result['subGroup'];
        }

        return $groupsList;
    }

    public function getAllStudentsInThisGroup($rootGroup, $subGroup)
    {
        $em = $this->getEntityManager();
        $query = $em->createQuery(
            'SELECT s.username, s.email
                    FROM ZenIgrooveBundle:Student s,  ZenIgrooveBundle:GroupComposition c
                    WHERE c.subGroup = :subGroup and c.rootGroup = :rootGroup and s.id = c.student'
        )
            ->setParameter('subGroup', $subGroup)
            ->setParameter('rootGroup', $rootGroup);
        $results = $query->getResult();
        $studentsUsernameList = array();
        foreach ($results as $result) {
            $studentsUsernameList[$result['username']] = $result['email'];
        }

        return $studentsUsernameList;
    }

*/

    public function createWithImportData($importedData, Provider $provider, $idOnProvider)
    {
        if (!$importedData instanceof \App\ImporterFilter\ImportedEntity\Group) {
            return null;
        }

        $group = new Group();
        $group->setName($importedData->getName());
        $group->setManageManually(false);
        $group->setProvider($provider);
        $group->setIdOnProvider($idOnProvider);
        if ($importedData->getSector() instanceof Sector) {
            $group->setSector($importedData->getSector());
        }
        $this->getEntityManager()->persist($group);
        $this->getEntityManager()->flush();

        return $group;
    }

    public function updateWithImportData(Group $group, $newData, Provider $provider)
    {
        if (!$newData instanceof \App\ImporterFilter\ImportedEntity\Group) {
            return $group;
        }

        $group->setName($newData->getName());

        if ($newData->getSector() instanceof Sector) {
            $group->setSector($newData->getSector());
        }

        $this->getEntityManager()->flush();

        return $group;
    }

    public function addGroup($provider, $groupName)
    {
        $em = $this->getEntityManager();
        $group = $em->getRepository('App\Entity\Group')->find($groupName);
        if (!$group) {
            $group = new Group();
            $group->setProvider($provider);
            $group->setName($groupName);
            $em->persist($group);
            $em->flush();
        }

        return $group;
    }
}
